(* Graphes non-orients dont les noeuds contiennent des 'a
   et dont les arcs sont dcors par des 'b *)

type ('a, 'b) t
type 'a node

(* Erreur, avec un message *)
exception Error of string

(* Crer un nouveau graphe *)
val create : 'a -> ('a, 'b) t

(* crer un nouveau sommet ajout graphe par effet de bord *)
val new_node : ('a, 'b) t -> 'a -> 'a node

(* new_edge g n1 n2 l, ajoute un arc entre n1 et n2 tiquett par l *)
val new_edge : ('a, 'b) t -> 'a node -> 'a node -> 'b ->  unit

(* exists_edge g n1 n2 l, teste l'existence d'un arc entre n1 et n2 et tiquett par l *)
val exists_edge : ('a, 'b) t -> 'a node -> 'a node -> 'b -> bool


(* itrer une fonctions sur tous les sommets du graphe *)
val iter : ('a, 'b) t -> ('a node -> unit) -> unit

(******************)
(* Lire le graphe *)
(******************)
(* liste de tous les noeuds, (ordre de creation) *)
val nodes : ('a, 'b) t -> 'a node list  
(* contenu d'un sommet *)
val info : ('a, 'b) t -> 'a node -> 'a           
(* voisins d'un sommet *)
val adj : ('a, 'b) t -> 'a node -> 'b -> 'a node list 
